/*-------------------------------------------------------------------+
 |          4 & 5 Digits                       MaEnv_02B_Digits.mq4  |
 |                                                 Copyright  2010  |
 |                                             basisforex@gmail.com  |
 +-------------------------------------------------------------------*/
#property copyright "Copyright  2010, basisforex@gmail.com"
#property link      "basisforex@gmail.com"
//-----
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Yellow
#property indicator_color2 Yellow
#property indicator_color3 Aqua
#property indicator_color4 Aqua
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_color7 Red
#property indicator_color8 Red

//----------------------------
extern string TimeFrame   = "Current time frame";
extern bool   Interpolate = true;
//----------------------------
double aquaUp1[];
double aquaDn1[];
double aquaUp2[];
double aquaDn2[];
double aquaUp3[];
double aquaDn3[];
double aquaUp4[];
double aquaDn4[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0, aquaUp1);
   SetIndexBuffer(1, aquaDn1);
   SetIndexBuffer(2, aquaUp2);
   SetIndexBuffer(3, aquaDn2);
   SetIndexBuffer(4, aquaUp3);
   SetIndexBuffer(5, aquaDn3);
   SetIndexBuffer(6, aquaUp4);
   SetIndexBuffer(7, aquaDn4);

      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
      
   return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
int start()
{
   int limit, counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
            limit = MathMin(Bars - counted_bars,Bars-1);
            if (returnBars) { aquaUp1[0] = limit+1; return(0); }
            if (timeFrame>Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   
   //
   //
   //
   //
   //
   
      double pointMultiplier=1; if (Digits==3 || Digits==5) pointMultiplier=10;

   //
   //
   //
   //
   //
      
   for(int i = limit; i >= 0; i--)
   {
      int y      = iBarShift(NULL,timeFrame,Time[i]);
      double yMA = (iMA(NULL, timeFrame,  30, 0, MODE_LWMA, PRICE_WEIGHTED, y) +
                    iMA(NULL, timeFrame,  50, 0, MODE_LWMA, PRICE_WEIGHTED, y) +
                    iMA(NULL, timeFrame, 100, 0, MODE_LWMA, PRICE_WEIGHTED, y)) / 3.0;
         
         aquaUp1[i] = yMA +  6.18 * Point * pointMultiplier;
         aquaDn1[i] = yMA -  6.18 * Point * pointMultiplier;
         aquaUp2[i] = yMA + 16.18 * Point * pointMultiplier;
         aquaDn2[i] = yMA - 16.18 * Point * pointMultiplier;
         aquaUp3[i] = yMA + 26.18 * Point * pointMultiplier;
         aquaDn3[i] = yMA - 26.18 * Point * pointMultiplier;
         aquaUp4[i] = yMA + 36.18 * Point * pointMultiplier;
         aquaDn4[i] = yMA - 36.18 * Point * pointMultiplier;
         
         //
         //
         //
         //
         //
      
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               aquaUp1[i+k] = aquaUp1[i] + (aquaUp1[i+n]-aquaUp1[i])*k/n;
               aquaDn1[i+k] = aquaDn1[i] + (aquaDn1[i+n]-aquaDn1[i])*k/n;
               aquaUp2[i+k] = aquaUp2[i] + (aquaUp2[i+n]-aquaUp2[i])*k/n;
               aquaDn2[i+k] = aquaDn2[i] + (aquaDn2[i+n]-aquaDn2[i])*k/n;
               aquaUp3[i+k] = aquaUp3[i] + (aquaUp3[i+n]-aquaUp3[i])*k/n;
               aquaDn3[i+k] = aquaDn3[i] + (aquaDn3[i+n]-aquaDn3[i])*k/n;
               aquaUp4[i+k] = aquaUp4[i] + (aquaUp4[i+n]-aquaUp4[i])*k/n;
               aquaDn4[i+k] = aquaDn4[i] + (aquaDn4[i+n]-aquaDn4[i])*k/n;
            }               
   }
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}